diff --git a/redis.c b/redis.c
index 539889799..b7f0a90be 100644
--- a/redis.c
+++ b/redis.c
@@ -56,6 +56,7 @@ extern zend_function_entry redis_cluster_functions[];
 PHP_INI_BEGIN()
     /* redis arrays */
     PHP_INI_ENTRY("redis.arrays.algorithm", "", PHP_INI_ALL, NULL)
+    PHP_INI_ENTRY("redis.arrays.auth", "", PHP_INI_ALL, NULL)
     PHP_INI_ENTRY("redis.arrays.autorehash", "0", PHP_INI_ALL, NULL)
     PHP_INI_ENTRY("redis.arrays.connecttimeout", "0", PHP_INI_ALL, NULL)
     PHP_INI_ENTRY("redis.arrays.distributor", "", PHP_INI_ALL, NULL)
diff --git a/redis_array.c b/redis_array.c
index db00c10b9..e0a3c9ffd 100644
--- a/redis_array.c
+++ b/redis_array.c
@@ -279,7 +279,7 @@ PHP_METHOD(RedisArray, __construct)
     long l_retry_interval = 0;
       zend_bool b_lazy_connect = 0;
     double d_connect_timeout = 0, read_timeout = 0.0;
-    zend_string *algorithm = NULL;
+    zend_string *algorithm = NULL, *auth = NULL;
     redis_array_object *obj;
 
     if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "z|a", &z0, &z_opts) == FAILURE) {
@@ -370,6 +370,11 @@ PHP_METHOD(RedisArray, __construct)
         if ((zpData = zend_hash_str_find(hOpts, "consistent", sizeof("consistent") - 1)) != NULL) {
             consistent = zval_is_true(zpData);
         }
+
+        /* auth */
+        if ((zpData = zend_hash_str_find(hOpts, "auth", sizeof("auth") - 1)) != NULL) {
+            auth = zval_get_string(zpData);
+        }
     }
 
     /* extract either name of list of hosts from z0 */
@@ -379,13 +384,14 @@ PHP_METHOD(RedisArray, __construct)
             break;
 
         case IS_ARRAY:
-            ra = ra_make_array(Z_ARRVAL_P(z0), &z_fun, &z_dist, hPrev, b_index, b_pconnect, l_retry_interval, b_lazy_connect, d_connect_timeout, read_timeout, consistent, algorithm TSRMLS_CC);
+            ra = ra_make_array(Z_ARRVAL_P(z0), &z_fun, &z_dist, hPrev, b_index, b_pconnect, l_retry_interval, b_lazy_connect, d_connect_timeout, read_timeout, consistent, algorithm, auth TSRMLS_CC);
             break;
 
         default:
             WRONG_PARAM_COUNT;
     }
     if (algorithm) zend_string_release(algorithm);
+    if (auth) zend_string_release(auth);
     zval_dtor(&z_dist);
     zval_dtor(&z_fun);
 
diff --git a/redis_array_impl.c b/redis_array_impl.c
index 0ec7755c3..c7e5c2b92 100644
--- a/redis_array_impl.c
+++ b/redis_array_impl.c
@@ -32,8 +32,8 @@
 
 extern zend_class_entry *redis_ce;
 
-RedisArray*
-ra_load_hosts(RedisArray *ra, HashTable *hosts, long retry_interval, zend_bool b_lazy_connect TSRMLS_DC)
+static RedisArray *
+ra_load_hosts(RedisArray *ra, HashTable *hosts, zend_string *auth, long retry_interval, zend_bool b_lazy_connect TSRMLS_DC)
 {
     int i = 0, host_len;
     char *host, *p;
@@ -77,6 +77,9 @@ ra_load_hosts(RedisArray *ra, HashTable *hosts, long retry_interval, zend_bool b
         /* create socket */
         redis->sock = redis_sock_create(host, host_len, port, ra->connect_timeout, ra->read_timeout, ra->pconnect, NULL, retry_interval);
 
+        /* copy password is specified */
+        if (auth) redis->sock->auth = zend_string_copy(auth);
+
         if (!b_lazy_connect)
         {
             /* connect */
@@ -178,9 +181,10 @@ RedisArray *ra_load_array(const char *name TSRMLS_DC) {
     zval z_params_read_timeout;
     zval z_params_lazy_connect;
     zval z_params_consistent;
+    zval z_params_auth;
     RedisArray *ra = NULL;
 
-    zend_string *algorithm= NULL;
+    zend_string *algorithm = NULL, *auth = NULL;
     zend_bool b_index = 0, b_autorehash = 0, b_pconnect = 0, consistent = 0;
     long l_retry_interval = 0;
     zend_bool b_lazy_connect = 0;
@@ -338,9 +342,17 @@ RedisArray *ra_load_array(const char *name TSRMLS_DC) {
         }
     }
 
+    /* find auth option */
+    array_init(&z_params_auth);
+    if ((iptr = INI_STR("redis.arrays.auth")) != NULL) {
+        sapi_module.treat_data(PARSE_STRING, estrdup(iptr), &z_params_auth TSRMLS_CC);
+    }
+    if ((z_data = zend_hash_str_find(Z_ARRVAL(z_params_auth), name, name_len)) != NULL) {
+        auth = zval_get_string(z_data);
+    }
 
     /* create RedisArray object */
-    ra = ra_make_array(hHosts, &z_fun, &z_dist, hPrev, b_index, b_pconnect, l_retry_interval, b_lazy_connect, d_connect_timeout, read_timeout, consistent, algorithm TSRMLS_CC);
+    ra = ra_make_array(hHosts, &z_fun, &z_dist, hPrev, b_index, b_pconnect, l_retry_interval, b_lazy_connect, d_connect_timeout, read_timeout, consistent, algorithm, auth TSRMLS_CC);
     if (ra) {
         ra->auto_rehash = b_autorehash;
         if(ra->prev) ra->prev->auto_rehash = b_autorehash;
@@ -348,6 +360,7 @@ RedisArray *ra_load_array(const char *name TSRMLS_DC) {
 
     /* cleanup */
     if (algorithm) zend_string_release(algorithm);
+    if (auth) zend_string_release(auth);
 
     zval_dtor(&z_params_hosts);
     zval_dtor(&z_params_prev);
@@ -362,6 +375,7 @@ RedisArray *ra_load_array(const char *name TSRMLS_DC) {
     zval_dtor(&z_params_read_timeout);
     zval_dtor(&z_params_lazy_connect);
     zval_dtor(&z_params_consistent);
+    zval_dtor(&z_params_auth);
     zval_dtor(&z_dist);
     zval_dtor(&z_fun);
 
@@ -409,8 +423,8 @@ ra_make_continuum(zend_string **hosts, int nb_hosts)
 }
 
 RedisArray *
-ra_make_array(HashTable *hosts, zval *z_fun, zval *z_dist, HashTable *hosts_prev, zend_bool b_index, zend_bool b_pconnect, long retry_interval, zend_bool b_lazy_connect, double connect_timeout, double read_timeout, zend_bool consistent, zend_string *algorithm TSRMLS_DC) {
-
+ra_make_array(HashTable *hosts, zval *z_fun, zval *z_dist, HashTable *hosts_prev, zend_bool b_index, zend_bool b_pconnect, long retry_interval, zend_bool b_lazy_connect, double connect_timeout, double read_timeout, zend_bool consistent, zend_string *algorithm, zend_string *auth TSRMLS_DC)
+{
     int i, count;
     RedisArray *ra;
 
@@ -430,7 +444,7 @@ ra_make_array(HashTable *hosts, zval *z_fun, zval *z_dist, HashTable *hosts_prev
     ra->continuum = NULL;
     ra->algorithm = NULL;
 
-    if (ra_load_hosts(ra, hosts, retry_interval, b_lazy_connect TSRMLS_CC) == NULL || !ra->count) {
+    if (ra_load_hosts(ra, hosts, auth, retry_interval, b_lazy_connect TSRMLS_CC) == NULL || !ra->count) {
         for (i = 0; i < ra->count; ++i) {
             zval_dtor(&ra->redis[i]);
             zend_string_release(ra->hosts[i]);
@@ -440,7 +454,7 @@ ra_make_array(HashTable *hosts, zval *z_fun, zval *z_dist, HashTable *hosts_prev
         efree(ra);
         return NULL;
     }
-    ra->prev = hosts_prev ? ra_make_array(hosts_prev, z_fun, z_dist, NULL, b_index, b_pconnect, retry_interval, b_lazy_connect, connect_timeout, read_timeout, consistent, algorithm TSRMLS_CC) : NULL;
+    ra->prev = hosts_prev ? ra_make_array(hosts_prev, z_fun, z_dist, NULL, b_index, b_pconnect, retry_interval, b_lazy_connect, connect_timeout, read_timeout, consistent, algorithm, auth TSRMLS_CC) : NULL;
 
     /* init array data structures */
     ra_init_function_table(ra);
diff --git a/redis_array_impl.h b/redis_array_impl.h
index 8159d6ed0..877b22f8d 100644
--- a/redis_array_impl.h
+++ b/redis_array_impl.h
@@ -9,9 +9,8 @@
 
 #include "redis_array.h"
 
-RedisArray *ra_load_hosts(RedisArray *ra, HashTable *hosts, long retry_interval, zend_bool b_lazy_connect TSRMLS_DC);
 RedisArray *ra_load_array(const char *name TSRMLS_DC);
-RedisArray *ra_make_array(HashTable *hosts, zval *z_fun, zval *z_dist, HashTable *hosts_prev, zend_bool b_index, zend_bool b_pconnect, long retry_interval, zend_bool b_lazy_connect, double connect_timeout, double read_timeout, zend_bool consistent, zend_string *algorithm TSRMLS_DC);
+RedisArray *ra_make_array(HashTable *hosts, zval *z_fun, zval *z_dist, HashTable *hosts_prev, zend_bool b_index, zend_bool b_pconnect, long retry_interval, zend_bool b_lazy_connect, double connect_timeout, double read_timeout, zend_bool consistent, zend_string *algorithm, zend_string *auth TSRMLS_DC);
 zval *ra_find_node_by_name(RedisArray *ra, const char *host, int host_len TSRMLS_DC);
 zval *ra_find_node(RedisArray *ra, const char *key, int key_len, int *out_pos TSRMLS_DC);
 void ra_init_function_table(RedisArray *ra);
